Name:           angie
Version:        1.0.0
Release:        1%{?dist}
Summary:        Powerful and scalable web server

License:        BSD-2-Clause
URL:            https://angie.software
Source0:        https://download.angie.software/files/%{name}-%{version}.tar.gz
Source1:        module-geoip2-3.4.tar.gz
Source2:        module-njs-0.7.9.tar.gz
Source3:        angie.conf
Source4:        default.conf
Source5:        example.conf
Source6:        LICENSE
Source7:        angie.logrotate
Source8:        angie.service
Source9:        angie.upgrade

BuildRequires:  make
BuildRequires:  gcc
BuildRequires:  openssl-devel 
BuildRequires:  pcre2-devel 
BuildRequires:  zlib-devel

Requires:       bash

BuildRequires:     systemd
Requires(post):    systemd
Requires(preun):   systemd
Requires(postun):  systemd

%description
Angie - an efficient, powerful and scalable web server, 
that was forked from angie by some of its former core devs, with 
intention to extend functionality far beyond original version.

%prep
rm -Rf %{_builddir}/*
%setup -q
tar -xpzf %{_sourcedir}/module-geoip2-3.4.tar.gz \
    -C %{_builddir}/angie-%{version}
tar -xpzf %{_sourcedir}/module-njs-0.7.9.tar.gz \
    -C %{_builddir}/angie-%{version}
cp -Rp %{_builddir}/angie-%{version} %{_builddir}/angie-%{version}-debug

%build
RPM_OPT_FLAGS=="$(echo %{optflags} $(pcre2-config --cflags)) -fPIC -Wno-maybe-uninitialized" # последний аргумент затыкает баг при сборке. Валентин обещал исправить.
RPM_LD_FLAGS=="-Wl,-z,relro -Wl,-z,now -pie"

CONFIGURE_OPTS="--prefix=/etc/angie \
                --conf-path=/etc/angie/angie.conf \
                --error-log-path=/var/log/angie/error.log \
                --http-log-path=/var/log/angie/access.log \
                --lock-path=/var/run/angie.lock \
                --modules-path=/usr/lib/angie/modules \
                --pid-path=/var/run/angie.pid \
                --sbin-path=/usr/sbin/angie \
                --http-client-body-temp-path=/var/cache/angie/client_temp \
                --http-fastcgi-temp-path=/var/cache/angie/fastcgi_temp \
                --http-proxy-temp-path=/var/cache/angie/proxy_temp \
                --http-scgi-temp-path=/var/cache/angie/scgi_temp \
                --http-uwsgi-temp-path=/var/cache/angie/uwsgi_temp \
                --user=angie \
                --group=angie \
                --with-compat \
                --with-file-aio \
                --with-http_addition_module \
                --with-http_auth_request_module \
                --with-http_dav_module \
                --with-http_flv_module \
                --with-http_gunzip_module \
                --with-http_gzip_static_module \
                --with-http_mp4_module \
                --with-http_random_index_module \
                --with-http_realip_module \
                --with-http_secure_link_module \
                --with-http_slice_module \
                --with-http_ssl_module \
                --with-http_stub_status_module \
                --with-http_sub_module \
                --with-http_v2_module \
                --with-mail \
                --with-mail_ssl_module \
                --with-stream \
                --with-stream_realip_module \
                --with-stream_ssl_module \
                --with-stream_ssl_preread_module \
                --with-threads \
                --with-http_image_filter_module=dynamic \
                --with-http_perl_module=dynamic \
                --with-http_xslt_module=dynamic \
                --add-dynamic-module=module-geoip2-3.4 \
                --add-dynamic-module=module-njs-0.7.9/nginx "

# ordinary
cd %{_builddir}/angie-%{version}
./configure $CONFIGURE_OPTS
make %{?_smp_mflags}

# debug
cd %{_builddir}/angie-%{version}-debug
./configure $CONFIGURE_OPTS --with-debug
make %{?_smp_mflags}

# njs
cd %{_builddir}/angie-%{version}/module-njs-0.7.9
make %{?_smp_mflags} clean
./configure
make %{?_smp_mflags}

%install
rm -Rf %{buildroot}
mkdir -p %{buildroot}

# perl
make %{?_smp_mflags} DESTDIR=%{buildroot}/perl INSTALLDIRS=vendor -f objs/Makefile install_perl_modules
find %{buildroot}/perl -not -name 'nginx.*' -type f -delete
find %{buildroot} -name nginx.bs -type f -delete
find %{buildroot}/perl -depth -type d -empty -delete
mv %{buildroot}/perl/* %{buildroot}
rmdir %{buildroot}/perl

# geoip2
install -Dm 0755 %{_builddir}/angie-%{version}/objs/ngx_http_geoip2_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_geoip2_module.so
install -Dm 0755 %{_builddir}/angie-%{version}-debug/objs/ngx_http_geoip2_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_geoip2_module-debug.so

install -Dm 0755 %{_builddir}/angie-%{version}/objs/ngx_stream_geoip2_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_stream_geoip2_module.so
install -Dm 0755 %{_builddir}/angie-%{version}-debug/objs/ngx_stream_geoip2_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_stream_geoip2_module-debug.so

# image-filter
install -Dm 0755 %{_builddir}/angie-%{version}/objs/ngx_http_image_filter_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_image_filter_module.so
install -Dm 0755 %{_builddir}/angie-%{version}-debug/objs/ngx_http_image_filter_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_image_filter_module-debug.so

# njs
install -Dm 0755 %{_builddir}/angie-%{version}/objs/ngx_http_js_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_js_module.so
install -Dm 0755 %{_builddir}/angie-%{version}-debug/objs/ngx_http_js_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_js_module-debug.so

install -Dm 0755 %{_builddir}/angie-%{version}/objs/ngx_stream_js_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_stream_js_module.so
install -Dm 0755 %{_builddir}/angie-%{version}-debug/objs/ngx_stream_js_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_stream_js_module-debug.so

install -Dm 0755 %{_builddir}/angie-%{version}/module-njs-0.7.9/build/njs \
    %{buildroot}%{_bindir}/njs

# perl
install -Dm 0755 %{_builddir}/angie-%{version}/objs/ngx_http_perl_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_perl_module.so
install -Dm 0755 %{_builddir}/angie-%{version}-debug/objs/ngx_http_perl_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_perl_module-debug.so

# xslt
install -Dm 0755 %{_builddir}/angie-%{version}/objs/ngx_http_xslt_filter_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_xslt_filter_module.so
install -Dm 0755 %{_builddir}/angie-%{version}-debug/objs/ngx_http_xslt_filter_module.so \
    %{buildroot}%{_libdir}/angie/modules/ngx_http_xslt_filter_module-debug.so

# angie
install -Dm 0755 %{_builddir}/angie-%{version}/objs/angie \
    %{buildroot}%{_sbindir}/angie-nodebug
install -Dm 0755 %{_builddir}/angie-%{version}-debug/objs/angie \
    %{buildroot}%{_sbindir}/angie-debug

ln -fs %{_sbindir}/angie-nodebug %{buildroot}%{_sbindir}/angie

install -Dm 0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/angie/angie.conf
install -Dm 0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/angie/http.d/default.conf
install -Dm 0644 %{SOURCE5} %{buildroot}%{_sysconfdir}/angie/stream.d/example.conf
install -Dm 0644 %{SOURCE6} %{buildroot}%{_datadir}/licenses/angie/LICENSE
install -Dm 0644 %{SOURCE7} %{buildroot}%{_sysconfdir}/logrotate.d/angie
install -Dm 0644 %{SOURCE8} %{buildroot}%{_unitdir}/angie.service
install -Dm 0755 %{SOURCE9} %{buildroot}%{_libexecdir}/initscripts/legacy-actions/angie/upgrade

install -dm 0755 %{buildroot}%{_datadir}/angie
mv %{_builddir}/angie-%{version}/html %{buildroot}%{_datadir}/angie

install -Dm 0644 %{_builddir}/angie-%{version}/conf/fastcgi.conf \
    -t %{buildroot}%{_sysconfdir}/angie
install -Dm 0644 %{_builddir}/angie-%{version}/conf/fastcgi_params \
    -t %{buildroot}%{_sysconfdir}/angie
install -Dm 0644 %{_builddir}/angie-%{version}/conf/mime.types \
    -t %{buildroot}%{_sysconfdir}/angie
install -Dm 0644 %{_builddir}/angie-%{version}/conf/scgi_params \
    -t %{buildroot}%{_sysconfdir}/angie
install -Dm 0644 %{_builddir}/angie-%{version}/conf/uwsgi_params \
    -t %{buildroot}%{_sysconfdir}/angie

install -Dm 0644 %{_builddir}/angie-%{version}/objs/angie.8 \
    %{buildroot}%{_mandir}/man8/angie.8

install -dm 0755 \
    %{buildroot}%{_localstatedir}/cache/angie \
    %{buildroot}%{_localstatedir}/log/angie \
    %{buildroot}%{_localstatedir}/run/angie \
    %{buildroot}%{_libdir}/angie/modules

ln -fs %{_libdir}/angie/modules %{buildroot}%{_sysconfdir}/angie/modules

%check
# don't include sources into -debuginfo
#TODO: check & re-make
#rm -Rf %{buildroot}/usr/src/debug/angie-1.0.0-1.el8.aarch64/*

%clean
rm -Rf %{buildroot}

%files
%{_sbindir}/angie
%{_sbindir}/angie-debug
%{_sbindir}/angie-nodebug

%dir %{_sysconfdir}/angie
%dir %{_sysconfdir}/angie/http.d
%dir %{_sysconfdir}/angie/stream.d

%config(noreplace) %{_sysconfdir}/angie/angie.conf
%config(noreplace) %{_sysconfdir}/angie/http.d/default.conf
%config(noreplace) %{_sysconfdir}/angie/stream.d/example.conf
%config(noreplace) %{_sysconfdir}/angie/fastcgi.conf
%config(noreplace) %{_sysconfdir}/angie/fastcgi_params
%config(noreplace) %{_sysconfdir}/angie/mime.types
%config(noreplace) %{_sysconfdir}/angie/scgi_params
%config(noreplace) %{_sysconfdir}/angie/uwsgi_params
%config(noreplace) %{_sysconfdir}/logrotate.d/angie

%{_sysconfdir}/angie/modules

%dir %{_datadir}/angie
%{_datadir}/angie/html

%doc CHANGES CHANGES.ru

%dir %{_datadir}/licenses/angie
%{_datadir}/licenses/angie/LICENSE

%dir %{_libdir}/angie
%dir %{_libdir}/angie/modules

%dir %{_libexecdir}/initscripts/legacy-actions/angie
%{_libexecdir}/initscripts/legacy-actions/angie/upgrade

%{_mandir}/man8/angie.8*

%{_unitdir}/angie.service

%attr(0755,root,root) %dir %{_localstatedir}/cache/angie
%attr(0755,root,root) %dir %{_localstatedir}/log/angie

%pre
# Add the "angie" user
getent group angie >/dev/null || groupadd -r angie
getent passwd angie >/dev/null || \
    useradd -r -g angie -s /sbin/nologin \
    -d %{_localstatedir}/cache/angie -c "angie user"  angie
exit 0

%post
# Register the angie service
if [ $1 -eq 1 ]; then
    /usr/bin/systemctl preset angie.service >/dev/null 2>&1 ||:
    # print site info
    cat <<BANNER
----------------------------------------------------------------------

Thanks for using Angie!

Please find the official documentation for Angie here:
* https://angie.software/en/

Please subscribe to angie-announce mailing list to get
the most important news about Angie:
* https://angie.software/en/contact/

----------------------------------------------------------------------
BANNER

    # Touch and set permisions on default log files on installation

    if [ -d %{_localstatedir}/log/angie ]; then
        if [ ! -e %{_localstatedir}/log/angie/access.log ]; then
            touch %{_localstatedir}/log/angie/access.log
            %{__chmod} 640 %{_localstatedir}/log/angie/access.log
            %{__chown} angie:angie %{_localstatedir}/log/angie/access.log
        fi

        if [ ! -e %{_localstatedir}/log/angie/error.log ]; then
            touch %{_localstatedir}/log/angie/error.log
            %{__chmod} 640 %{_localstatedir}/log/angie/error.log
            %{__chown} angie:angie %{_localstatedir}/log/angie/error.log
        fi
    fi
fi

%preun
if [ $1 -eq 0 ]; then
    /usr/bin/systemctl --no-reload disable angie.service >/dev/null 2>&1 ||:
    /usr/bin/systemctl stop angie.service >/dev/null 2>&1 ||:
fi

%postun
/usr/bin/systemctl daemon-reload >/dev/null 2>&1 ||:
if [ $1 -ge 1 ]; then
    /sbin/service angie status  >/dev/null 2>&1 || exit 0
    /sbin/service angie upgrade >/dev/null 2>&1 || echo \
        "Binary upgrade failed, please check angie's error.log"
fi


%package module-geoip2
Summary:           Angie GeoIP2 module
BuildRequires:     libmaxminddb-devel
Requires:          angie = %{version}-%{release}
 
%description module-geoip2
%{summary}.

%files module-geoip2
%{_libdir}/angie/modules/ngx_http_geoip2_module.so
%{_libdir}/angie/modules/ngx_http_geoip2_module-debug.so
%{_libdir}/angie/modules/ngx_stream_geoip2_module.so
%{_libdir}/angie/modules/ngx_stream_geoip2_module-debug.so

%post module-geoip2
if [ $1 -eq 1 ]; then
  cat <<BANNER
----------------------------------------------------------------------

The GeoIP2 dynamic modules for Angie have been installed.
To enable these modules, add the following to /etc/angie/angie.conf
and reload angie:

    load_module modules/ngx_http_geoip2_module.so;
    load_module modules/ngx_stream_geoip2_module.so;

Please refer to the modules documentation for further details:
https://github.com/leev/ngx_http_geoip2_module

----------------------------------------------------------------------
BANNER
fi


%package module-image-filter
Summary:           Angie image filter module
BuildRequires:     gd-devel
Requires:          angie = %{version}-%{release}
 
%description module-image-filter
%{summary}.

%files module-image-filter
%{_libdir}/angie/modules/ngx_http_image_filter_module.so
%{_libdir}/angie/modules/ngx_http_image_filter_module-debug.so

%post module-image-filter
if [ $1 -eq 1 ]; then
  cat <<BANNER
----------------------------------------------------------------------

The image-filter dynamic module for Angie has been installed.
To enable this module, add the following to /etc/angie/angie.conf
and reload angie:

    load_module modules/ngx_http_image_filter_module.so;

Please refer to the modules documentation for further details:
https://angie.software/r/en/docs/http/ngx_http_image_filter_module.html

----------------------------------------------------------------------
BANNER
fi


%package module-njs
Summary:           Angie njs module
BuildRequires:     libedit-devel
Requires:          angie = %{version}-%{release}
 
%description module-njs
%{summary}.

%files module-njs
%{_bindir}/njs
%{_libdir}/angie/modules/ngx_http_js_module.so
%{_libdir}/angie/modules/ngx_http_js_module-debug.so
%{_libdir}/angie/modules/ngx_stream_js_module.so
%{_libdir}/angie/modules/ngx_stream_js_module-debug.so

%post module-njs
if [ $1 -eq 1 ]; then
  cat <<BANNER
----------------------------------------------------------------------

The njs dynamic modules for Angie have been installed.
To enable these modules, add the following to /etc/angie/angie.conf
and reload angie:

    load_module modules/ngx_http_js_module.so;
    load_module modules/ngx_stream_js_module.so;

Please refer to the modules documentation for further details:
https://angie.software/r/en/docs/njs/
https://angie.software/r/en/docs/http/ngx_http_js_module.html
https://angie.software/r/en/docs/stream/ngx_stream_js_module.html

----------------------------------------------------------------------
BANNER
fi


%package module-perl
Summary:           Angie perl module
BuildRequires:     perl-devel
BuildRequires:     perl-generators
BuildRequires:     perl(ExtUtils::Embed)
Requires:          angie = %{version}-%{release}
#Requires:          perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
#Requires:          perl(constant)
 
%description module-perl
%{summary}.

%files module-perl
%{_libdir}/angie/modules/ngx_http_perl_module.so
%{_libdir}/angie/modules/ngx_http_perl_module-debug.so
%dir %{perl_vendorarch}/auto/nginx
%{perl_vendorarch}/auto/nginx/nginx.so
%{perl_vendorarch}/nginx.pm
%{_mandir}/man3/nginx.3pm.gz

%post module-perl
if [ $1 -eq 1 ]; then
  cat <<BANNER
----------------------------------------------------------------------

The Perl dynamic module for Angie has been installed.
To enable this module, add the following to /etc/angie/angie.conf
and reload angie:

    load_module modules/ngx_http_perl_module.so;

Please refer to the modules documentation for further details:
https://angie.software/r/en/docs/http/ngx_http_perl_module.html

----------------------------------------------------------------------
BANNER
fi


%package module-xslt
Summary:           Angie XSLT module
BuildRequires:     libxslt-devel
Requires:          angie = %{version}-%{release}
 
%description module-xslt
%{summary}.

%files module-xslt
%{_libdir}/angie/modules/ngx_http_xslt_filter_module.so
%{_libdir}/angie/modules/ngx_http_xslt_filter_module-debug.so

%post module-xslt
if [ $1 -eq 1 ]; then
  cat <<BANNER
----------------------------------------------------------------------

The XSLT dynamic module for Angie has been installed.
To enable this module, add the following to /etc/angie/angie.conf
and reload angie:

    load_module modules/ngx_http_xslt_filter_module.so;

Please refer to the modules documentation for further details:
https://angie.software/r/en/docs/http/ngx_http_xslt_module.html

----------------------------------------------------------------------
BANNER
fi

%changelog
* Wed Dec 28 2022 Release Engineering Team <devops@tech.wbsrv.ru> - angie-1.0.0-1
- new version 1.0.0

# -*- Bash -*-
